Subject: [PATCH RFC v2 08/12] soc: samsung: pm_domain: Add support for parent power domain

From: [email-masked] (Marek Szyprowski)
Date: Wed, 03 Dec 2014 09:36:27 +0100

Hello,

On 2014-11-25 10:19, Geert Uytterhoeven wrote:
> On Tue, Nov 25, 2014 at 9:57 AM, amit daniel kachhap
> <[email-masked]>  wrote:
>>>> diff --git a/Documentation/devicetree/bindings/arm/exynos/power_domain.txt b/Documentation/devicetree/bindings/arm/exynos/power_domain.txt
>>>> index 00ebda1..0160bdc 100644
>>>> --- a/Documentation/devicetree/bindings/arm/exynos/power_domain.txt
>>>> +++ b/Documentation/devicetree/bindings/arm/exynos/power_domain.txt
>>>> @@ -24,6 +24,7 @@ Optional Properties:
>>>>          - pclkN, clkN: Pairs of parent of input clock and input clock to the
>>>>                  devices in this power domain. Maximum of 4 pairs (N = 0 to 3)
>>>>                  are supported currently.
>>>> +- parents: phandle of parent power domains.
> Why not using just "power-domains = <&pd_top>"?
> This is consistent with how clocks refer to their parent clocks.

I agree. The only question is weather exynos dts should keep using 
samsung,power-domain
property, or switch to generic 'power-domains' approach. I assume that 
exynos-pm driver
should support both.

>>>>   Node of a device using power domains must have a samsung,power-domain property
>>>>   defined with a phandle to respective power domain.
>>>> @@ -48,6 +49,7 @@ Example:
>>>>          mfc_pd: power-domain at 10044060 {
>>>>                  compatible = "samsung,exynos4210-pd", "samsung,exynos7-pd-mfc";
>>>>                  reg = <0x10044060 0x20>;
>>>> +               parents = <&pd_top>;
>>>>                  #power-domain-cells = <0>;
>>>>          };
>>> This seems like a good and generic approach to describe that a PM
>>> domain could have a parent. I would suggest to rename it, such it
>>> reflects its a PM domain binding though.
>> I am not sure if this is generic. I guess PD's represented like below
>> are more generic.
>> PD1 {
>>          PD2 {
>>                  PD3 {
>>                  };
>>          };
>> };
> Such a representation is not always possible.
> If you have one power-controller for a hierarchy of PM domains, you can
> use it.
> If you have multiple power-controllers, the power controller nodes are at the
> same level in DT, so you'll have to use "power-domains" properties to link
> them together.

I agree. I will send updated patch for this purpose for existing exynos4 
power domain driver.

Best regards
-- 
Marek Szyprowski, PhD
Samsung R&D Institute Poland